//*****************************************************************************************************
//  1. t@C
//		FftSpectrogramView.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XyNgO̓Ot̃EBhENX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2007.08.09 S.Aizawa VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "MMA_G.h"
#include "FftSpectrogramDlg.h"
#include "FftSpectrogramView.h"
#include "Define.h"

// XN[o[̍ől
#define SCROLL_MAX		0x7ffffffe

// CFftSpectrogramView

IMPLEMENT_DYNAMIC(CFftSpectrogramView, CWnd)

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::CFftSpectrogramView
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CFftSpectrogramView::CFftSpectrogramView()
{
	// oϐ
	m_sizeBitmap = 0;
	m_bDispGraph = FALSE;
	m_nCursorX = 0;
	m_nCursorY = 0;
	m_bTrackMouse = FALSE;
	m_penCursor.CreatePen(PS_DOT, 1, COLOR_GRAPH_CURSOR);
	m_bAutoScroll = FALSE;
}


BEGIN_MESSAGE_MAP(CFftSpectrogramView, CWnd)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_HSCROLL()
	ON_WM_NCHITTEST()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_NCLBUTTONUP()
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()


//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::PreSubclassWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		TuNX
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::PreSubclassWindow()
{
	// 
	Initialize();

	CWnd::PreSubclassWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::OnEraseBkgnd
//----------------------------------------------------------------------------------------------------
//  2. @\
//		wi`揈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC			*pDC			[I] foCXReLXgւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE
//*****************************************************************************************************
BOOL CFftSpectrogramView::OnEraseBkgnd(CDC *pDC)
{
	// Ȃ
	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::OnPaint
//----------------------------------------------------------------------------------------------------
//  2. @\
//		yCg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::OnPaint()
{
	CPaintDC dc(this);

	// NCAg̈̃TCY擾
	CRect rect;
	GetClientRect(&rect);

	if (m_bDispGraph) {
		// Ot̃rbg}bvʂɓ]
		CBitmap *pBitmapOrg = m_dcGraph.SelectObject(&m_bmpGraph);
		dc.BitBlt(0, 0, rect.Width(), rect.Height(), &m_dcGraph, 0, 0, SRCCOPY);

		// J[\`
		if (m_nCursorX >= m_cFftSpectrogramDraw.m_rectScale.left
				&& m_nCursorX <= m_cFftSpectrogramDraw.m_rectScale.right
				&& m_nCursorY >= m_cFftSpectrogramDraw.m_rectScale.top
				&& m_nCursorY <= m_cFftSpectrogramDraw.m_rectScale.bottom) {
			CRect &rectScale = m_cFftSpectrogramDraw.m_rectScale;
			CPen *pPenOrg = dc.SelectObject(&m_penCursor);
			dc.MoveTo(m_nCursorX, rectScale.top);
			dc.LineTo(m_nCursorX, rectScale.bottom);
			dc.MoveTo(rectScale.left, m_nCursorY);
			dc.LineTo(rectScale.right, m_nCursorY);
			dc.SelectObject(pPenOrg);
		}

		m_dcGraph.SelectObject(pBitmapOrg);
	} else {
		// O[œhԂ
		CBrush brush;
		brush.CreateSysColorBrush(COLOR_MENU);
		dc.FillRect(&rect, &brush);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::Initialize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::Initialize()
{
	// foCXReLXg쐬
	CDC *pDC = GetDC();
	m_dcGraph.CreateCompatibleDC(pDC);
	ReleaseDC(pDC);

	// XN[o[\
	ShowScrollBar(SB_HORZ, TRUE);
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::DispGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		*pDataG				[I] ̓XyNgOf[^ւ̃|C^
//		int			nFreqData			[I] ǧ
//		int			nTimeData			[I] Ԏ̌
//		double		fSampleRate			[I] TvO[g
//		double		fTimeMin			[I] Ԏ̍ŏl
//		double		fTimeMax			[I] Ԏ̍ől
//		double		fTimeOffset			[I] Ԏ̃ItZbg
//		double		fTimeZoom			[I] Ԏ̃Y[
//		double		fFreqMin			[I] g̍ŏl
//		double		fFreqMax			[I] g̍ől
//		BOOL		bFreqLog			[I] g̑ΐXP[tO
//		double		fLevelMin			[I] x̍ŏl
//		double		fLevelMax			[I] x̍ől
//		BOOL		bLevelLog			[I] x̑ΐXP[tO
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::DispGraph(const double *pDataG, int nFreqData, int nTimeData, double fSampleRate, double fTimeMin, double fTimeMax, double fTimeOffset, double fTimeZoom, double fFreqMin, double fFreqMax, BOOL bFreqLog, double fLevelMin, double fLevelMax, BOOL bLevelLog)
{
	if (m_hWnd == NULL)
		return;

	// NCAg̈̑傫ɍ킹ărbg}bv쐬
	CRect rectClinet;
	GetClientRect(&rectClinet);
	CSize sizeView(rectClinet.Width(), rectClinet.Height());
	if (m_sizeBitmap != sizeView) {
		m_sizeBitmap = sizeView;

		CDC *pDC = GetDC();
		m_bmpGraph.DeleteObject();
		m_bmpGraph.CreateCompatibleBitmap(pDC, m_sizeBitmap.cx, m_sizeBitmap.cy);
		ReleaseDC(pDC);
	}

	// foCXReLXgɃrbg}bvݒ
	CBitmap *pBitmapOrg = m_dcGraph.SelectObject(&m_bmpGraph);

	// Ot`
	m_cFftSpectrogramDraw.DrawGraph(m_dcGraph, rectClinet, pDataG, nFreqData, nTimeData, fSampleRate, fTimeMin, fTimeMax, fTimeOffset, fTimeZoom, fFreqMin, fFreqMax, bFreqLog, fLevelMin, fLevelMax, bLevelLog);

	// foCXReLXgrbg}bv
	m_dcGraph.SelectObject(pBitmapOrg);

	// Ot\tOZbg
	m_bDispGraph = TRUE;

	// EBhE̖
	Invalidate(FALSE);

	// EBhEXV
	UpdateWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::HideGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::HideGraph()
{
	// Ot\tOZbg
	m_bDispGraph = FALSE;

	// ʕ`
	Invalidate();
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::OnMouseMove
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] Ă鉼zL[
//		CPoint		point			[I] }EX̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::OnMouseMove(UINT nFlags, CPoint point)
{
	if (!m_bAutoScroll) {
		CFftSpectrogramDlg *pWnd = (CFftSpectrogramDlg *)GetParent();

		// }EXJ[\XP[΃J[\ʒuf[^\
		CRect &rectScale = m_cFftSpectrogramDraw.m_rectScale;
		if (rectScale.PtInRect(point)) {
			if (!m_bTrackMouse) {
				TRACKMOUSEEVENT tme;
				tme.cbSize = sizeof(TRACKMOUSEEVENT);
				tme.dwFlags = TME_LEAVE;
				tme.hwndTrack = m_hWnd;
				::TrackMouseEvent(&tme);

				m_bTrackMouse = TRUE;
			}

			pWnd->SetCursor((double)(point.x - rectScale.left) / rectScale.Width(), (double)(rectScale.bottom - point.y) / rectScale.Height());
		} else {
			pWnd->SetCursor(0, 0);
		}
	}

	CWnd::OnMouseMove(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::OnMouseLeave
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXJ[\EBhEOֈړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM		wParam			[I] WM_MOUSELEAVEbZ[Wp[^
//		LPARAM		lParam			[I] WM_MOUSELEAVEbZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		0
//*****************************************************************************************************
LRESULT CFftSpectrogramView::OnMouseLeave(WPARAM wParam, LPARAM lParam)
{
	CFftSpectrogramDlg *pWnd = (CFftSpectrogramDlg *)GetParent();

	// J[\ʒuf[^
	pWnd->SetCursor(0, 0);
	m_bTrackMouse = FALSE;

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::DispCursor
//----------------------------------------------------------------------------------------------------
//  2. @\
//		J[\\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fPosX			[I] 0`1ɐKꂽJ[\XW
//		double		fPosY			[I] 0`1ɐKꂽJ[\YW
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::DispCursor(double fPosX, double fPosY)
{
	int nCursorX = 0;
	int nCursorY = 0;

	// J[\XWvZ
	CRect &rectScale = m_cFftSpectrogramDraw.m_rectScale;
	nCursorX = rectScale.left + (int)(rectScale.Width() * fPosX);

	// J[\YWvZ
	if (fPosY != 0) {
		nCursorY = rectScale.bottom - (int)(rectScale.Height() * fPosY + 0.5);
		if (nCursorY < rectScale.top || nCursorY > rectScale.bottom)
			nCursorY = 0;
	}

	// ړĂĕ\
	if (nCursorX != m_nCursorX || nCursorY != m_nCursorY) {
		m_nCursorX = nCursorX;
		m_nCursorY = nCursorY;
		Invalidate(FALSE);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::OnHScroll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nSBCode			[I] XN[vR[h
//		UINT		nPos			[I] XN[{bNẌʒu
//		CScrollBar	*pScrollBar		[I] XN[o[Rg[ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO si;

	// ݂̃XN[擾
	GetScrollInfo(SB_HORZ, &si);
	int nPageSize = si.nPage;
	int nLineSize = nPageSize / 32;
	if (nLineSize == 0)
		nLineSize = 1;

	// XN[ʒuXV
	switch (nSBCode) {
	case SB_LEFT:
		nPos = 0;
		break;
	case SB_LINELEFT:
		nPos = si.nPos - nLineSize;
		break;
	case SB_LINERIGHT:
		nPos = si.nPos + nLineSize;
		break;
	case SB_PAGELEFT:
		nPos = si.nPos - nPageSize;
		break;
	case SB_PAGERIGHT:
		nPos = si.nPos + nPageSize;
		break;
	case SB_RIGHT:
		nPos = si.nMax - si.nPage;
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		nPos = si.nTrackPos;
		break;
	default:
		return;
	}

	if (nPos != si.nPos) {
		CFftSpectrogramDlg *pFftSpectrogramDlg = (CFftSpectrogramDlg *)GetParent();

		// XN[
		pFftSpectrogramDlg->TimeScroll((double)nPos / si.nMax);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::OnNcHitTest
//----------------------------------------------------------------------------------------------------
//  2. @\
//		NCAg̈qbgeXgiXN[o[Lɂ邽߂ɕKvj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CPoint		point			[I] J[\ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		DefWindowProc̕Ԃl
//*****************************************************************************************************
LRESULT CFftSpectrogramView::OnNcHitTest(CPoint point)
{
	return ::DefWindowProc(m_hWnd, WM_NCHITTEST, 0, MAKELPARAM(point.x, point.y));
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::OnNcLButtonDowniXN[o[Lɂ邽߂ɕKvj
//----------------------------------------------------------------------------------------------------
//  2. @\
//		NCAg̈}EX_E
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nHitTest		[I] qbgeXg
//		CPoint		point			[I] J[\ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::OnNcLButtonDown(UINT nHitTest, CPoint point)
{
	::DefWindowProc(m_hWnd, WM_NCLBUTTONDOWN, nHitTest, MAKELPARAM(point.x, point.y));
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::OnNcLButtonUp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		NCAg̈}EXAbviXN[o[Lɂ邽߂ɕKvj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nHitTest		[I] qbgeXg
//		CPoint		point			[I] J[\ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::OnNcLButtonUp(UINT nHitTest, CPoint point)
{
	::DefWindowProc(m_hWnd, WM_NCLBUTTONUP, nHitTest, MAKELPARAM(point.x, point.y));
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::SetTimeScrollBar
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[ݒ菈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fTimeOffset			[I] ԃItZbg
//		double		fTimeZoom			[I] ԃY[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::SetTimeScrollBar(double fTimeOffset, double fTimeZoom)
{
	SCROLLINFO si;

	memset(&si, 0, sizeof(si));
	si.cbSize = sizeof(si);
	si.fMask = SIF_PAGE | SIF_POS | SIF_RANGE;
	si.nMax = SCROLL_MAX;
	si.nMin = 0;
	si.nPage = (int)(SCROLL_MAX / fTimeZoom);
	if (si.nPage == 0)
		si.nPage = 1;
	si.nPos = (int)(SCROLL_MAX * fTimeOffset);

	SetScrollInfo(SB_HORZ, &si);
}

//*****************************************************************************************************
//  1. ֐
//		CFftSpectrogramView::OnLButtonDown
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EX{^_E
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] Ă鉼zL[
//		CPoint		point			[I] J[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CFftSpectrogramView::OnLButtonDown(UINT nFlags, CPoint point)
{
	CFftSpectrogramDlg *pWnd = (CFftSpectrogramDlg *)GetParent();

	// }EXJ[\XP[΃J[\ʒuf[^\
	CRect &rectScale = m_cFftSpectrogramDraw.m_rectScale;
	if (rectScale.PtInRect(point))
		pWnd->SetCursor((double)(point.x - rectScale.left) / rectScale.Width(), (double)(rectScale.bottom - point.y) / rectScale.Height());
	else
		pWnd->SetCursor(0, 0);

	CWnd::OnLButtonDown(nFlags, point);
}
